#include <marr.h>
#include <stdlib.h>

marr_da_t* _marr_new(size_t stride, size_t cap) {
    marr_da_t* da = malloc(sizeof(marr_da_t));
    da->data = malloc(stride * cap);
    if (!da->data) {
        return NULL;
    }
    da->cap = cap;
    da->len = 0;
    return da;
}

int _marr_push_front(marr_da_t* da, void* val) {}

int _marr_push_back(marr_da_t* da, void* val);
int _marr_pop_front(marr_da_t* da, void* dest);
int _marr_pop_back(marr_da_t* da, void* dest);
int _marr_append(marr_da_t* to, marr_da_t* from);

int _marr_resize(marr_da_t* da, size_t new_cap) {
    if (new_cap <= da->cap) {
        return 1;
    }
    da->data = realloc(da->data, new_cap * da->stride);
    if (!da->data) {
        return 1;
    }
    return 0;
}

int _marr_remove(marr_da_t* da, size_t idx);
bool _marr_contains(marr_da_t* da, void* val);
bool _marr_map(marr_da_t* da, marr_da_t* da_out, bool (*func)(void* item, void* data), void* data);
